# Importa Bibliotecas
import numpy as np
import matplotlib.pyplot as plt
from scipy.stats import pearsonr, spearmanr

# Zera as Listas
rho_list = []
pol_list = []
pvalue2_list = []
r_list = []
pvalue1_list =[]
header = []

# Zera as variaveis
rho_max = 0
rho_temp = 0
pol_max = 0

# Le o arquivo
file_in = input("Type CSV file name =>")

# Le os graus
degree_polmin = int(input("Type an integer for the min degree of the polynomial =>"))
degree_polmax = int(input("Type an integer for the max degree of the polynomial =>"))

# cria contador intervalo
cont = degree_polmax - degree_polmin

# Le csv
my_csv = np.genfromtxt (file_in, delimiter=",", skip_header = 1)

# gera as colunas
x = my_csv[:,0]
y = my_csv[:,1]

# gera minimos e maximos
x_min = np.min(x)
x_max = np.max(x)

# Set up an axis for the least-square polynomial
x1 = np.linspace(x_min,x_max,1000)


# Faz loop com for e intervalo aberto
for pol in range (degree_polmin, degree_polmax + 1, 1):

    # Generate plot
    plt.scatter(x,y,marker= "^",color = "black")

    # Least-squares polynomial fitting (degree must be an integer)
    pol_list.append(pol)

    z = np.polyfit(x,y,pol)  # Get the equation coefficients
    p = np.poly1d(z)         # Generate polynomial equation


    # Calculate Pearson Correlation Coefficient
    r, pvalue1 = pearsonr(y,p(x))
    r_list.append(round(r,3))
    pvalue1_list.append(pvalue1)

    # Calculate Spearman's Rank-Order Correlation Coefficient
    rho, pvalue2 = spearmanr(y,p(x))
    pvalue2_list.append(pvalue2)
    rho = round(rho,3)
    rho_list.append(rho)

    # Compara e define os máximos
    if (rho >= rho_temp):
        rho_max = rho_temp
        rho_temp = rho
        pol_max = pol

# Plota o grafico com o máximo rho
plt.plot(x1, p(x1), color="blue")
plt.xlabel('x-axis') # Adds axis label
plt.ylabel('y-axis') # Adds axis label
str_title = "Maxinum rho is " + str(rho_temp) + " for degree " + str(pol_max)
plt.title(str_title) # Adds title
plt.show()

#printa os dados concatenados
print("------------------------------------")
print("Degree")
print(pol_list)
print("------------------------------------")
print("rho")
print(rho_list)
print("------------------------------------")
print("p-value")
print(pvalue2_list)
print("------------------------------------")
print("r")
print(r_list)
print("------------------------------------")
print("p-value")
print(pvalue1_list)
print("#####################################")
print("Maxinum rho is %.3f for degree %d" % (rho_temp,pol_max))
print("#####################################")

# # Some editing of the file_in string
file_out = file_in[:len(file_in)-4]
# # Save plot on png file
plt.savefig(file_out+'_degree_pol_'+str(pol_max)+'.png')
